#ifndef LIST_H
#define LIST_H

#ifndef NULL
#define NULL ((void *) 0)
#endif

/*
 *
 * Sada maker pro praci s obousmernym spojovym seznamem
 *
 */

#define LIST_INSERT(list, node)	do { \
	if (list) { \
		(node)->prev = (list); \
		(node)->next = (list)->next; \
		(node)->next->prev = (node); \
		(node)->prev->next = (node); \
	} else { \
		(node)->prev = (node); \
		(node)->next = (node); \
		list = (node); \
	} \
} while (0)

#define LIST_REMOVE(list, node) do { \
	if ((node) == (node)->next) { \
		list = NULL;\
	} else { \
		(node)->prev->next = (node)->next; \
		(node)->next->prev = (node)->prev; \
		if ((list) == (node)) { \
			list = (node)->next; \
		} \
	} \
} while(0)
#endif
