#ifndef TASKS_H
#define TASKS_H

#define MAX_PATH_LEN           (255)  /* maximalni velikost cesty */
#define MAX_FILES_OPENED	(20)  /* maximalni pocet popisovacu souboru */

/** struktura popisujici aktualne bezici proces */
struct task {
	int last_err_code;                    /* navratovy kod, se kterym byla ukoncena posledni aplikace */
	unsigned long min_brk;                /* minimalni hranice oblasti s daty */
	unsigned long cur_brk;                /* aktualni hranice oblasti s daty */
	struct mufs_fd *fd[MAX_FILES_OPENED]; /* descriptory otevrenych souboru */
};

void jumpto_scheduler();
void jumpto_task(unsigned long entry);
void task_exec_shell();
void task_exec(char *path);

#endif
